type DiffResult = {
    t: 0 | 1 | 2;
    p: Array<string | number>;
    v?: unknown;
};

/**
 * Performs a deep difference between two objects.
 *
 * @example
 * diff({a: 1}, {a: 5}) //=> [{t: 2, p: ['a'], v: 5}]
 */
declare function diff(obj1: object, obj2: object): Array<DiffResult>;

export { type DiffResult, diff };
